/*
 * Copyright (c) 1998, 2002 Sandro Sigala.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <fx.h>

#include "fxzacman.h"

class GameWidget;

class MainWindow: public FXMainWindow {
    	FXDECLARE(MainWindow)

private:
       	FXXPMIcon *bigicon, *smallicon;
       	FXMenuPane *filemenu, *optionsmenu, *skillmenu, *helpmenu;
	FXLabel *time_label, *pills_label;
 	GameWidget *game;
  	FXDataTarget skill_target, sound_target;
       	FXTimer *timerhandle;
	int skill;
	FXuint lastkeytime;

protected:
	MainWindow();

private:
  	MainWindow(const MainWindow&);
  	MainWindow& operator =(const MainWindow&);

public:
  	long onCmdNew		(FXObject *, FXSelector, void *);
  	long onCmdPause		(FXObject *, FXSelector, void *);
  	long onUpdPause		(FXObject *, FXSelector, void *);
  	long onCmdHighScore	(FXObject *, FXSelector, void *);
	long onCmdIconify	(FXObject *, FXSelector, void *);
  	long onCmdQuit		(FXObject *, FXSelector, void *);
  	long onCmdSkill		(FXObject *, FXSelector, void *);
  	long onCmdSound		(FXObject *, FXSelector, void *);
  	long onCmdAbout		(FXObject *, FXSelector, void *);
  	long onCmdUp		(FXObject *, FXSelector, void *);
  	long onCmdDown		(FXObject *, FXSelector, void *);
  	long onCmdLeft		(FXObject *, FXSelector, void *);
  	long onCmdRight		(FXObject *, FXSelector, void *);
        long onTimer		(FXObject *, FXSelector, void *);

public:
    	enum {
        	ID_GAME = FXMainWindow::ID_LAST,
		ID_NEW,
		ID_PAUSE,
            	ID_HIGHSCORE,
		ID_ICONIFY,
            	ID_QUIT,
		ID_SKILL,
		ID_SOUND,
            	ID_ABOUT,
            	ID_UP,
            	ID_DOWN,
            	ID_LEFT,
            	ID_RIGHT,
            	ID_TIMER,
            	ID_LAST
    	};

public:
	MainWindow(FXApp *app);
	~MainWindow();

  	virtual void create();
};

#endif // !MAINWINDOW_H

